\ CONTENT : Bit manipulation words
\ LANGUAGE : ANSI FORTH
\ PROJECT : hcc primes
\ CATEGORY : EXAMPLE
\ AUTOR :  AH
\ LAST CHANGE : 930302 AH SHIFT updates (changes to DPANS)
\ LAST CHANGE : 911110 AH created

\ WARNING : All bit map indexing from with 1 not from 0
\ Only import from other part of prime project

\ Create
 : CreateSMask
    CREATE
    1
    BITS/CELL 0 DO
      DUP ,
      1 LSHIFT
    LOOP
    DROP
; PRIVATE

 : CreateCMask
    CREATE
    1
    BITS/CELL 0 DO
      DUP INVERT ,
      1 LSHIFT
    LOOP
    DROP
; PRIVATE

CreateSMask   SetMask    PRIVATE        \ Mask for setting bits
CreateCMask   ClearMask  PRIVATE        \ Mask for clearing bits

: 32/MOD   ( May be redefined in assembler )
    BITS/CELL /MOD
; PRIVATE

: ClearBit ( Packed bits, BIT# --  clears the specified bit)
           1-
           32/MOD CELLS ROT + SWAP  \ Address in flags table
           CELLS ClearMask + @         \ Get mask
           OVER @ AND SWAP ! \ Clear the bit
;

: SetBit ( Packed bits, BIT# --  sets the specified bit)
           1-
           32/MOD CELLS ROT + SWAP  \ Address in flags table
           CELLS SetMask + @         \ Get mask
           OVER @ OR SWAP !  \ Store with bit set
;

: TestBit ( Packed bits, BIT# -- FLAG  Gets a FLAG testable by IF)
           1-
           32/MOD CELLS ROT + @ SWAP  \ Get flag
           CELLS SetMask + @ AND        \ Result: =0 or #0
;
