\  LANGUAGE    : ANSI FORTH with tForth extensions
\  NAME        : LINKS1E.FRT
\  PROJECT     : Factoring
\  CONTENT     : placing of the links, starting sieves
\  CATEGORY    : EXAMPLE
\  AUTHOR      : AH 931127
\  LAST CHANGE : AH Array of channel addresses
\

\ *******************************************************************
\     This file configured for one external link on LINK0
\ *******************************************************************

        REVISION -links   "--- link                Version 2    ---"

        PRIVATES
\
\
\  The main processor communicates using links 1, 2 and 3 and
\    2 memory channels.
\  The secondary processors use link1 to pmain, and of course link0 to the PC.
\
\                                        /----->-----\
\                PC <-- link0 --> pmain <             > forth-process
\                 ^               | | |  \-----<-----/
\                 |       .-------' | `-------.
\                 |       |         |         |
\                 |     plink1   plink2    plink3
\                 |       |         |         |
\                 |     link1     link1     link1
\                ///      |         |         |
\                 |      pr1       pr2       pr3
\                 |       |         |         |
\                 `-------+---------+---------'
\
\  So the sieving processors / processes see LINK1 / two memory channels.
\
\ Nice colors are e.g. green red blue magenta
USE-GRAPHICS 0= [IF]    \ Define dummy colors
   VALUE green
   VALUE red
   VALUE blue
   VALUE magenta
[THEN]

\

I'mRoot [IF]

\ Add a link (two channels) to the array the main process is using
\ for communication. `C1' is input to main, `C2' is output from main.
: AddLink       ( <C1> <C2> -- )
 TO (( ChannelsUsed )) TpColor[]
 TO (( ChannelsUsed )) MainOut[]
 TO (( ChannelsUsed )) MainIn[]
 TRUE TO (( ChannelsUsed )) WaitWork[]
 1 +TO ChannelsUsed
;

CHANNEL one
CHANNEL two
two           TO SieverIn
one           TO SieverOut

FORTH-PROCESS Siever
LO-PRIO  ' GoSieve RUN Siever            \ start par process
one two magenta AddLink

LINK1-IN LINK1-OUT green AddLink

\ Stop all the `Siever' processes
: StopSievers  ( <> -- <> )
     ChannelsUsed 0 DO
        %>stop I MainOut[] CHANNEL-!
     LOOP
;

[ELSE]
LINK0-IN      TO SieverIn
LINK0-OUT     TO SieverOut

FORTH-PROCESS Siever

[THEN]
